Index: trunk/src/VBox/Devices/Audio/DevCodec.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DevCodec.cpp	(revision 31083)
+++ trunk/src/VBox/Devices/Audio/DevCodec.cpp	(revision 31084)
@@ -123,5 +123,5 @@
     int rc;
     rc = codecUnimplemented(pState, cmd, pResp);
-    *pResp |= CODEC_RESPONSE_UNSOLICITED; 
+    *pResp |= CODEC_RESPONSE_UNSOLICITED;
     return rc;
 }
@@ -132,17 +132,17 @@
     PCODECNODE pNode = &pState->pNodes[CODEC_NID(cmd)];
     if (STAC9220_IS_DAC_CMD(cmd))
-        *pResp = AMPLIFIER_REGISTER(pNode->dac.B_params, 
-                            CODEC_B_DIRECTION(cmd), 
-                            CODEC_B_SIDE(cmd), 
+        *pResp = AMPLIFIER_REGISTER(pNode->dac.B_params,
+                            CODEC_B_DIRECTION(cmd),
+                            CODEC_B_SIDE(cmd),
                             CODEC_B_INDEX(cmd));
     else if (STAC9220_IS_ADCVOL_CMD(cmd))
-        *pResp = AMPLIFIER_REGISTER(pNode->adcvol.B_params, 
-                            CODEC_B_DIRECTION(cmd), 
-                            CODEC_B_SIDE(cmd), 
+        *pResp = AMPLIFIER_REGISTER(pNode->adcvol.B_params,
+                            CODEC_B_DIRECTION(cmd),
+                            CODEC_B_SIDE(cmd),
                             CODEC_B_INDEX(cmd));
     else if (STAC9220_IS_ADCMUX_CMD(cmd))
-        *pResp = AMPLIFIER_REGISTER(pNode->adcmux.B_params, 
-                            CODEC_B_DIRECTION(cmd), 
-                            CODEC_B_SIDE(cmd), 
+        *pResp = AMPLIFIER_REGISTER(pNode->adcmux.B_params,
+                            CODEC_B_DIRECTION(cmd),
+                            CODEC_B_SIDE(cmd),
                             CODEC_B_INDEX(cmd));
     else {
@@ -159,17 +159,17 @@
     *pResp = 0;
     if (STAC9220_IS_DAC_CMD(cmd))
-        pu32Bparam = &AMPLIFIER_REGISTER(pNode->dac.B_params, 
-            CODEC_B_DIRECTION(cmd), 
-            CODEC_B_SIDE(cmd), 
+        pu32Bparam = &AMPLIFIER_REGISTER(pNode->dac.B_params,
+            CODEC_B_DIRECTION(cmd),
+            CODEC_B_SIDE(cmd),
             CODEC_B_INDEX(cmd));
     else if (STAC9220_IS_ADCVOL_CMD(cmd))
-        pu32Bparam = &AMPLIFIER_REGISTER(pNode->adcvol.B_params, 
-            CODEC_B_DIRECTION(cmd), 
-            CODEC_B_SIDE(cmd), 
+        pu32Bparam = &AMPLIFIER_REGISTER(pNode->adcvol.B_params,
+            CODEC_B_DIRECTION(cmd),
+            CODEC_B_SIDE(cmd),
             CODEC_B_INDEX(cmd));
     else if (STAC9220_IS_ADCMUX_CMD(cmd))
-        pu32Bparam = &AMPLIFIER_REGISTER(pNode->adcmux.B_params, 
-            CODEC_B_DIRECTION(cmd), 
-            CODEC_B_SIDE(cmd), 
+        pu32Bparam = &AMPLIFIER_REGISTER(pNode->adcmux.B_params,
+            CODEC_B_DIRECTION(cmd),
+            CODEC_B_SIDE(cmd),
             CODEC_B_INDEX(cmd));
     Assert(pu32Bparam);
@@ -239,6 +239,6 @@
     if (STAC9220_IS_ADC_CMD(cmd))
     {
-        pState->pNodes[CODEC_NID(cmd)].adc.u32F03_param &= ~CODEC_VERB_8BIT_DATA; 
-        pState->pNodes[CODEC_NID(cmd)].adc.u32F03_param |= cmd & CODEC_VERB_8BIT_DATA; 
+        pState->pNodes[CODEC_NID(cmd)].adc.u32F03_param &= ~CODEC_VERB_8BIT_DATA;
+        pState->pNodes[CODEC_NID(cmd)].adc.u32F03_param |= cmd & CODEC_VERB_8BIT_DATA;
     }
     *pResp = 0;
@@ -260,6 +260,6 @@
     if (STAC9220_IS_SPDIFOUT_CMD(cmd))
     {
-        pState->pNodes[CODEC_NID(cmd)].spdifout.u32F0d_param &= ~CODEC_VERB_8BIT_DATA; 
-        pState->pNodes[CODEC_NID(cmd)].spdifout.u32F0d_param |= cmd & CODEC_VERB_8BIT_DATA; 
+        pState->pNodes[CODEC_NID(cmd)].spdifout.u32F0d_param &= ~CODEC_VERB_8BIT_DATA;
+        pState->pNodes[CODEC_NID(cmd)].spdifout.u32F0d_param |= cmd & CODEC_VERB_8BIT_DATA;
     }
     *pResp = 0;
@@ -272,6 +272,6 @@
     if (STAC9220_IS_SPDIFOUT_CMD(cmd))
     {
-        pState->pNodes[CODEC_NID(cmd)].spdifout.u32F0d_param &= ~(CODEC_VERB_8BIT_DATA << 8); 
-        pState->pNodes[CODEC_NID(cmd)].spdifout.u32F0d_param |= cmd & (CODEC_VERB_8BIT_DATA << 8); 
+        pState->pNodes[CODEC_NID(cmd)].spdifout.u32F0d_param &= ~(CODEC_VERB_8BIT_DATA << 8);
+        pState->pNodes[CODEC_NID(cmd)].spdifout.u32F0d_param |= cmd & (CODEC_VERB_8BIT_DATA << 8);
     }
     *pResp = 0;
@@ -400,6 +400,6 @@
         case 1:
             pNode->afg.node.name = "AFG";
-            pNode->node.au32F00_param[4] = RT_MAKE_U32_FROM_U8(0x1a, 0x00, 0x02, 0x00); 
-            pNode->node.au32F00_param[5] = RT_MAKE_U32_FROM_U8(0x1, 0x01, 0x00, 0x0); 
+            pNode->node.au32F00_param[4] = RT_MAKE_U32_FROM_U8(0x1a, 0x00, 0x02, 0x00);
+            pNode->node.au32F00_param[5] = RT_MAKE_U32_FROM_U8(0x1, 0x01, 0x00, 0x0);
             pNode->node.au32F00_param[8] = RT_MAKE_U32_FROM_U8(0x0d, 0x0d, 0x01, 0x0); /* Capabilities */
             //pNode->node.au32F00_param[0xa] = RT_BIT(19)|RT_BIT(18)|RT_BIT(17)|RT_BIT(10)|RT_BIT(9)|RT_BIT(8)|RT_BIT(7)|RT_BIT(6)|RT_BIT(5);
@@ -660,5 +660,5 @@
     uint32_t multFrq = CODEC_FMT_MUL_FRQ(dacFmt);
     switch (baseFrq)
-    {   
+    {
         case 0: baseFrq = 48000; break;
         case 0x1: baseFrq = 44100; break;
@@ -685,5 +685,5 @@
         case 0x7: divFrq = 8; break;
     }
-    return baseFrq * multFrq / divFrq; 
+    return baseFrq * multFrq / divFrq;
 }
 static int codec_dac_to_aud(CODECState *pState, int dacnum, audsettings_t *paud)
@@ -691,7 +691,7 @@
     uint32_t dacfmt = pState->pNodes[dacnum].dac.u32A_param;
     paud->freq = 44100;//codecFrequencyCalculate(dacfmt);
-    paud->nchannels = 2;//CODEC_DAC_CHANELS(dacfmt); 
+    paud->nchannels = 2;//CODEC_DAC_CHANELS(dacfmt);
     paud->fmt = AUD_FMT_U16;
-    
+
     paud->endianness = 0;
     return VINF_SUCCESS;
@@ -701,5 +701,5 @@
 {
     CODECState *pState = (CODECState *)opaque;
-    pState->pfnTransfer(pState, PI_INDEX, avail); 
+    pState->pfnTransfer(pState, PI_INDEX, avail);
 }
 
@@ -707,5 +707,5 @@
 {
     CODECState *pState = (CODECState *)opaque;
-    pState->pfnTransfer(pState, PO_INDEX, avail); 
+    pState->pfnTransfer(pState, PO_INDEX, avail);
 }
 
@@ -713,5 +713,5 @@
 {
     CODECState *pState = (CODECState *)opaque;
-    pState->pfnTransfer(pState, MC_INDEX, avail); 
+    pState->pfnTransfer(pState, MC_INDEX, avail);
 }
 #define STAC9220_DAC_PI (0x2)
@@ -732,5 +732,5 @@
     AUD_register_card ("ICH0", &pState->card);
 
-    
+
     codec_dac_to_aud(pState, STAC9220_DAC_PI, &as);
     pState->voice_pi = AUD_open_in(&pState->card, pState->voice_pi, "hda.in", pState, pi_callback, &as);